import { __awaiter, __generator } from 'tslib';
import { createInstance, LOCALSTORAGE } from 'localforage';
import { SubscriptionClient } from 'subscriptions-transport-ws';
import { ApolloClient } from 'apollo-client';
import { createHttpLink } from 'apollo-link-http';
import { WebSocketLink } from 'apollo-link-ws';
import { InMemoryCache } from 'apollo-cache-inmemory';
import { split } from 'apollo-link';
import { getMainDefinition } from 'apollo-utilities';
import { delay } from 'bluebird';
import { NgModule, APP_INITIALIZER, Optional, SkipSelf } from '@angular/core';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/services/ec.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function ECLite() { }
if (false) {
    /** @type {?} */
    ECLite.prototype.fetch;
    /** @type {?} */
    ECLite.prototype.WebSocket;
}
var EdgeCentralConfig = /** @class */ (function () {
    function EdgeCentralConfig() {
    }
    return EdgeCentralConfig;
}());
if (false) {
    /** @type {?} */
    EdgeCentralConfig.prototype.cloudCentralHost;
    /** @type {?} */
    EdgeCentralConfig.prototype.edgeCN;
    /** @type {?} */
    EdgeCentralConfig.prototype.ecvcHost;
    /** @type {?} */
    EdgeCentralConfig.prototype.inSecure;
}
/**
 * @record
 */
function EdgeCentralClientConfig() { }
if (false) {
    /** @type {?} */
    EdgeCentralClientConfig.prototype.apiUrl;
    /** @type {?} */
    EdgeCentralClientConfig.prototype.subscriptionUrl;
    /** @type {?} */
    EdgeCentralClientConfig.prototype.token;
}
var EdgeCentralClient = /** @class */ (function () {
    /* eslint-disable no-useless-constructor */
    function EdgeCentralClient(config) {
        this.config = config;
        this.httpProtocol = 'https';
        this.wsProtocol = 'wss';
        this.store = createInstance({
            name: 'ec-client',
            driver: LOCALSTORAGE
        });
        if (config.inSecure) {
            // set protocol to insecure protocol
            this.httpProtocol = 'http';
            this.wsProtocol = 'ws';
        }
    }
    /**
     * @return {?}
     */
    EdgeCentralClient.prototype.isAuthenticated = /**
     * @return {?}
     */
    function () {
        return __awaiter(this, void 0, void 0, function () {
            var config;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: 
                    // TODO: use more shopisticated detection mechanism
                    return [4 /*yield*/, delay(500)];
                    case 1:
                        // TODO: use more shopisticated detection mechanism
                        _a.sent();
                        /* eslint-disable no-console */
                        console.log('using chrome extensions?', this.isUsingChromeExtension());
                        if (this.isUsingChromeExtension()) {
                            return [2 /*return*/, true];
                        }
                        return [4 /*yield*/, this.getClientConfig()];
                    case 2:
                        config = _a.sent();
                        if (!config.token) {
                            return [2 /*return*/, false];
                        }
                        return [2 /*return*/, true];
                }
            });
        });
    };
    /**
     * return true when chrome inject script from ec-lite extenstion are presents
     */
    /**
     * return true when chrome inject script from ec-lite extenstion are presents
     * @return {?}
     */
    EdgeCentralClient.prototype.isUsingChromeExtension = /**
     * return true when chrome inject script from ec-lite extenstion are presents
     * @return {?}
     */
    function () {
        if (window.eclite) {
            return true;
        }
        return false;
    };
    /**
     * @return {?}
     */
    EdgeCentralClient.prototype.loadApolloClient = /**
     * @return {?}
     */
    function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this;
                        return [4 /*yield*/, this.createApolloClient()];
                    case 1:
                        _a.client = _b.sent();
                        console.log('client loaded!', this.client);
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @return {?}
     */
    EdgeCentralClient.prototype.createApolloClient = /**
     * @return {?}
     */
    function () {
        return __awaiter(this, void 0, void 0, function () {
            var config, httpLink, wsClient, wsLink, cache, link, client;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: 
                    // TODO: use more shopisticated detection mechanism
                    return [4 /*yield*/, delay(500)];
                    case 1:
                        // TODO: use more shopisticated detection mechanism
                        _a.sent();
                        // get client configurations
                        return [4 /*yield*/, this.getClientConfig()];
                    case 2:
                        config = _a.sent();
                        // HTTP connection to the API
                        httpLink = createHttpLink({
                            uri: config.apiUrl,
                            fetch: (/**
                             * @param {?} input
                             * @param {?} init
                             * @return {?}
                             */
                            function (input, init) { return __awaiter(_this, void 0, void 0, function () {
                                var conf, url;
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0: return [4 /*yield*/, this.getClientConfig()];
                                        case 1:
                                            conf = _a.sent();
                                            url = conf.apiUrl || input;
                                            // set authorization header
                                            if (init.headers && init.headers.set) {
                                                init.headers.set('Authorization', "Bearer " + conf.token);
                                            }
                                            else {
                                                init.headers = init.headers || ((/** @type {?} */ ({})));
                                                init.headers.Authorization = "Bearer " + conf.token;
                                            }
                                            // using eclite offline first fetch
                                            // when chrome extension are present
                                            if (this.isUsingChromeExtension()) {
                                                return [2 /*return*/, window.eclite.fetch(url, init)];
                                            }
                                            return [2 /*return*/, fetch(url, init)];
                                    }
                                });
                            }); })
                        });
                        // subscriptions link
                        wsClient = new SubscriptionClient(config.subscriptionUrl, {
                            reconnect: true,
                            connectionParams: {
                                token: config.token
                            }
                        }, 
                        // using eclite offline first websocket
                        // when chrome extension are present
                        this.isUsingChromeExtension() ? window.eclite.WebSocket : WebSocket);
                        wsLink = new WebSocketLink(wsClient);
                        // Cache implementation
                        cache = new InMemoryCache();
                        // using the ability to split links, you can send data to each link
                        // depending on what kind of operation is being sent
                        link = split((
                        // split based on operation type
                        // split based on operation type
                        /**
                         * @param {?} __0
                         * @return {?}
                         */
                        function (_a) {
                            var query = _a.query;
                            /** @type {?} */
                            var definition = getMainDefinition(query);
                            return (definition.kind === 'OperationDefinition' &&
                                definition.operation === 'subscription');
                        }), wsLink, httpLink);
                        // Create apollo client
                        client = new ApolloClient({
                            link: link,
                            cache: cache
                        });
                        return [2 /*return*/, client];
                }
            });
        });
    };
    /**
     * @param {?} config
     * @return {?}
     */
    EdgeCentralClient.prototype.setClientConfig = /**
     * @param {?} config
     * @return {?}
     */
    function (config) {
        return this.store.setItem('config', config);
    };
    /**
     * @return {?}
     */
    EdgeCentralClient.prototype.getClientConfig = /**
     * @return {?}
     */
    function () {
        return __awaiter(this, void 0, void 0, function () {
            var config;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.store.getItem('config')];
                    case 1:
                        config = _a.sent();
                        // using default config when config not present
                        if (!config) {
                            return [2 /*return*/, {
                                    apiUrl: "https://" + this.config.ecvcHost + "/graphql",
                                    subscriptionUrl: "wss://" + this.config.ecvcHost + "/subscriptions",
                                    token: null
                                }];
                        }
                        return [2 /*return*/, config];
                }
            });
        });
    };
    /**
     * logout and clear client contexts
     */
    /**
     * logout and clear client contexts
     * @return {?}
     */
    EdgeCentralClient.prototype.logout = /**
     * logout and clear client contexts
     * @return {?}
     */
    function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.store.removeItem('config')];
                    case 1:
                        _a.sent();
                        window.location.replace('/login');
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @param {?} providerId
     * @param {?} password
     * @return {?}
     */
    EdgeCentralClient.prototype.loginByProvider = /**
     * @param {?} providerId
     * @param {?} password
     * @return {?}
     */
    function (providerId, password) {
        return __awaiter(this, void 0, void 0, function () {
            var res, errMessage, token;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, fetch(this.httpProtocol + "://" + this.config.cloudCentralHost + "/login-provider", {
                            method: 'POST',
                            mode: 'cors',
                            headers: {
                                'Content-Type': 'application/json'
                            },
                            body: JSON.stringify({
                                provider_id: providerId,
                                password: password
                            })
                        })];
                    case 1:
                        res = _a.sent();
                        if (!res.ok) {
                            errMessage = 'Gagal melakukan login';
                            switch (res.status) {
                                case 404:
                                case 403:
                                case 401:
                                    errMessage = 'Kode Faskes & Password tidak cocok';
                                    break;
                                case 500:
                                    errMessage = 'Maaf, Server kami mengalami gangguan';
                                    break;
                            }
                            throw new Error(errMessage);
                        }
                        // get token
                        return [4 /*yield*/, res.json()];
                    case 2:
                        token = (_a.sent()).token;
                        // apply configurations
                        return [4 /*yield*/, this.setClientConfig({
                                apiUrl: this.httpProtocol + "://" + this.config.ecvcHost + "/graphql",
                                subscriptionUrl: this.wsProtocol + "://" + this.config.ecvcHost + "/subscriptions",
                                token: token
                            })];
                    case 3:
                        // apply configurations
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @param {?} deviceId
     * @return {?}
     */
    EdgeCentralClient.prototype.loginByDevice = /**
     * @param {?} deviceId
     * @return {?}
     */
    function (deviceId) {
        return __awaiter(this, void 0, void 0, function () {
            var apiUrl, subscriptionUrl, err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        apiUrl = this.httpProtocol + "://" + deviceId + "." + this.config.edgeCN + "/graphql";
                        subscriptionUrl = this.wsProtocol + "://" + deviceId + "." + this.config.edgeCN + "/subscriptions";
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, fetch(apiUrl, {
                                method: 'POST',
                                mode: 'cors',
                                headers: {
                                    'Content-Type': 'application/json'
                                },
                                body: JSON.stringify({
                                    query: "{\n            __schema {\n              types {\n                name\n              }\n            }\n          }",
                                    operationName: null,
                                    variables: {}
                                })
                            })];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        err_1 = _a.sent();
                        throw new Error('Gagal mendapatkan koneksi, pastikan device anda dalam satu jaringan');
                    case 4: 
                    // apply configurations
                    return [4 /*yield*/, this.setClientConfig({
                            apiUrl: apiUrl,
                            subscriptionUrl: subscriptionUrl,
                            token: '--ec-on-device-token--'
                        })];
                    case 5:
                        // apply configurations
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    return EdgeCentralClient;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    EdgeCentralClient.prototype.store;
    /** @type {?} */
    EdgeCentralClient.prototype.client;
    /**
     * @type {?}
     * @private
     */
    EdgeCentralClient.prototype.httpProtocol;
    /**
     * @type {?}
     * @private
     */
    EdgeCentralClient.prototype.wsProtocol;
    /**
     * @type {?}
     * @private
     */
    EdgeCentralClient.prototype.config;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ec.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Load apollo client on booting
 * @param {?} ec
 * @return {?}
 */
function initEdgeCentralClient(ec) {
    /** @type {?} */
    var loader = (/**
     * @return {?}
     */
    function () { return ec.loadApolloClient(); });
    return loader;
}
/**
 * wrapped edge central client so it injectable
 * @param {?} config
 * @return {?}
 */
function provideEdgeCentralService(config) {
    return new EdgeCentralClient(config);
}
/**
 *
 * @export
 */
var EdgeCentralModule = /** @class */ (function () {
    /**
     * Creates an instance of EdgeCentralModule.
     * throw error if EdgeCentralModule already created on parent
     */
    function EdgeCentralModule(parentModule) {
        if (parentModule) {
            throw new Error('EdgeCentralModule is already loaded. Import it in the AppModule only');
        }
    }
    /**
     * Create new module instance with edge central config service
     *
     */
    /**
     * Create new module instance with edge central config service
     *
     * @param {?} config
     * @return {?}
     */
    EdgeCentralModule.forRoot = /**
     * Create new module instance with edge central config service
     *
     * @param {?} config
     * @return {?}
     */
    function (config) {
        return {
            ngModule: EdgeCentralModule,
            providers: [{ provide: EdgeCentralConfig, useValue: config }]
        };
    };
    EdgeCentralModule.decorators = [
        { type: NgModule, args: [{
                    providers: [
                        {
                            provide: EdgeCentralClient,
                            useFactory: provideEdgeCentralService,
                            deps: [EdgeCentralConfig]
                        },
                        // intiate edge central client on booting
                        {
                            provide: APP_INITIALIZER,
                            useFactory: initEdgeCentralClient,
                            deps: [EdgeCentralClient],
                            multi: true
                        }
                    ]
                },] }
    ];
    /** @nocollapse */
    EdgeCentralModule.ctorParameters = function () { return [
        { type: EdgeCentralModule, decorators: [{ type: Optional }, { type: SkipSelf }] }
    ]; };
    return EdgeCentralModule;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: sirusdev-ec-client-angular.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { EdgeCentralClient, EdgeCentralConfig, EdgeCentralModule, initEdgeCentralClient, provideEdgeCentralService };
//# sourceMappingURL=sirusdev-ec-client-angular.js.map
